<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Autologin.php,v 1.2 2005/04/15 13:07:47 mike Exp $
 */

/**
 * Requires Gadget_Service_Auth
 */
class_exists('Gadget_Service_Auth') or require_once 'Gadget/Service/Auth.php';

/**
 * Gadget_Service_Autologin
 *
 * Gadget's default autologin service.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @since       1.0
 */
class Gadget_Service_Autologin extends Gadget_Service_Auth
{
    var $service = SERVICE_AUTOLOGIN;
    
    /**
     * Execute
     * 
     * @access  protected
     * @return  bool
     * @param   string  $alias
     * @param   string  $password
     */
    function execute($alias, $password)
    {
        return parent::execute($alias, $password, 'in');
    }
    
    /**
     * On Failure
     * 
     * @access  protected
     * @return  bool false
     */
    function onFailure()
    {
        Gadget::callProviderSet(PROVIDER_AUTOLOGIN, false);
        return Gadget_Service::onFailure();
    }
    
}

?>
