<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.6 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Errornotify.php,v 1.6 2005/04/15 13:07:47 mike Exp $
 */

/**
 * Requires Gadget_Service
 */
class_exists('Gadget_Service') or require_once 'Gadget/Service.php';

/**
 * Gadget_Service_Errornotify
 *
 * Gadget's default error notify service.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @since       1.0
 */
class Gadget_Service_Errornotify extends Gadget_Service
{
    var $service = SERVICE_ERRORNOTIFY;
    var $mail;
    
    /**
     * Init
     * 
     * @access  protected
     * @return  void
     */
    function init()
    {
        class_exists('Mail') or require_once 'Mail.php';
        $opts = Gadget::getConf('Mail');
        $this->mail = &Mail::factory($opts['driver'], $opts);
    }
    
    /**
     * Execute
     * 
     * @access  protected
     * @return  bool
     * @param   object
     */
    function execute($error)
    {
        if (PEAR::isError($this->mail)) {
            return false;
        }
        
        // mail body
        ob_start();
        print_r($error);
        $body = ob_get_clean();

        $opts = Gadget::getConf('Mail');
        
        // mail headers
        class_exists('HTTP') or require_once 'HTTP.php';
        $hdrs = array(                      
            'Subject'   => 'PEAR Error at '. HTTP::absoluteUri(),
            'From'      => $opts['admin'],
            'Date'      => gmdate('r'),
        );
        
        // send mail
        return !PEAR::isError($this->mail->send($opts['admin'], $hdrs, $body));
    }
    
    /**
     * On Failure
     * 
     * @access  protected
     * @return  bool false
     */
    function onFailure()
    {
        // disable E_NOTIFY if we failed
        Gadget::onError(Gadget::onError() &~ E_NOTIFY);
        PEAR::raiseError('Gadget::onError(E_NOTIFY) has been disabled!');
        return false;
    }
    
}

?>
