<?php

/**
 * Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.3 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: b64.php,v 1.3 2005/04/18 11:40:37 mike Exp $
 */

/**
 * Requires Gadget_Template_Action
 */
class_exists('Gadget_Template_Action') or require_once 'Gadget/Template/Action.php';

/** 
 * Gadget_Template_Action_b64
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Action_b64 extends Gadget_Template_Action
{
    /**
     * Name
     * 
     * @var string
     */
    var $name = 'b64';
    
    /**
     * Recursive Pattern
     * 
     * @var string
     */
    var $recursivePattern = 'b64:?';
    
    /**
     * PHP Callback
     * 
     * @access  public
     * @return  string
     * @param   array
     */
    function phpCallback($args)
    {
        return base64_decode(trim($args[1]));
    }
    
    /**
     * RAW Callback
     * 
     * @access  public
     * @return  string
     * @param   array   $args
     */
    function rawCallback($args)
    {
        return base64_decode(trim($args[1]));
    }
    
}

?>
